hdu 1531 King

King

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 2013    Accepted Submission(s): 932


Problem Description
Once, in one kingdom, there was a queen and that queen was expecting a baby. The queen prayed: ``If my child was a son and if only he was a sound king.'' After nine months her child was born, and indeed, she gave birth to a nice son. 
Unfortunately, as it used to happen in royal families, the son was a little retarded. After many years of study he was able just to add integer numbers and to compare whether the result is greater or less than a given integer number. In addition, the numbers had to be written in a sequence and he was able to sum just continuous subsequences of the sequence. 

The old king was very unhappy of his son. But he was ready to make everything to enable his son to govern the kingdom after his death. With regards to his son's skills he decided that every problem the king had to decide about had to be presented in a form of a finite sequence of integer numbers and the decision about it would be done by stating an integer constraint (i.e. an upper or lower limit) for the sum of that sequence. In this way there was at least some hope that his son would be able to make some decisions. 

After the old king died, the young king began to reign. But very soon, a lot of people became very unsatisfied with his decisions and decided to dethrone him. They tried to do it by proving that his decisions were wrong. 

Therefore some conspirators presented to the young king a set of problems that he had to decide about. The set of problems was in the form of subsequences Si = {aSi, aSi+1, ..., aSi+ni} of a sequence S = {a1, a2, ..., an}. The king thought a minute and then decided, i.e. he set for the sum aSi + aSi+1 + ... + aSi+ni of each subsequence Si an integer constraint ki (i.e. aSi + aSi+1 + ... + aSi+ni < ki or aSi + aSi+1 + ... + aSi+ni > ki resp.) and declared these constraints as his decisions. 

After a while he realized that some of his decisions were wrong. He could not revoke the declared constraints but trying to save himself he decided to fake the sequence that he was given. He ordered to his advisors to find such a sequence S that would satisfy the constraints he set. Help the advisors of the king and write a program that decides whether such a sequence exists or not.
 
Input
The input consists of blocks of lines. Each block except the last corresponds to one set of problems and king's decisions about them. In the first line of the block there are integers n, and m where 0 < n <= 100 is length of the sequence S and 0 < m <= 100 is the number of subsequences Si. Next m lines contain particular decisions coded in the form of quadruples si, ni, oi, ki, where oi represents operator > (coded as gt) or operator < (coded as lt) respectively. The symbols si, ni and ki have the meaning described above. The last block consists of just one line containing 0.
 
Output
The output contains the lines corresponding to the blocks in the input. A line contains text successful conspiracy when such a sequence does not exist. Otherwise it contains text lamentable kingdom. There is no line in the output corresponding to the last ``null'' block of the input.
 
Sample Input
4 2 1 2 gt 0 2 2 lt 2 1 2 1 0 gt 0 1 0 lt 0 0
 
Sample Output
lamentable kingdom successful conspiracy
 
Source
 
Recommend
LL   |   We have carefully selected several similar problems for you:   1596  1529  1598  1142  1245 
 
思路:

题意 :给出一些限制,问这个序列是否存在
限制的类型是: s[a+b]-s[a-1]>k或者<k
下面分析差分约数系统成立的条件:不存在环(正负);
由于该题只让你分析是否存在矛盾,所以我们采用最短路或者最长路的方法均可
即s[n]-s[0]>=ans ans 不为无穷大
或者 s[n]-s[0]<=ans ans 不为无穷小
通过spfa的的入队次数即可判断环的存在>>>

同时需要判断图的连通性,该图不连通所以建立超级源点,使图变联通

考虑下图不连通的后果:如果图不连通我们在求最短路的时候会有相当一部分的独立的全部都是INF的变量

其次呢>>为了保证联通我们从超级源点连一条权值是0的边>>>考虑这样的合法性>>

这样的话在不经过负边的松弛的情况下,所有的点都是0>>因为一组解同时加上某个值不会影响这些的结果

考虑加上0边使其联通的话会不会导致松弛出项现错误

最短路>>>负边没关系>>正边两点的差值为0正好满足   最长路同理

66666666

#include<bits/stdc++.h>
using namespace std;
const int INF=0x3f3f3f3f;
struct edge{int to,v;};
vector<edge>g[510];
char str[100];int n,m;
int dis[510],vis[510],t_[510];
bool spfa(int s){
    memset(dis,INF,sizeof(dis));
    memset(vis,0,sizeof(vis));
    memset(t_,0,sizeof(t_));
    queue<int>q;
    dis[s]=0;vis[s]=1;q.push(s);t_[s]++;
    while(!q.empty()){
        int u=q.front();q.pop();vis[u]=0;
        for(int i=0;i<g[u].size();i++){
            edge v=g[u][i];
            if(dis[v.to]>dis[u]+v.v){
                dis[v.to]=dis[u]+v.v;
                if(!vis[v.to]){
                    q.push(v.to);
                    t_[v.to]++;
                    if(t_[v.to]>n+1) return false;
                    vis[v.to]=1;
                }
            }
        }
    }
    return true;
}
int main(){
    int a,b,k;
    while(~scanf("%d",&n),n){
        scanf("%d",&m);int s=110,t=-1;
        for(int i=0;i<110;i++) g[i].clear(); 
        //-sum[si+ni]+sum[si-1]<=-k-1
        //sum[si+ni]-sum[si-1]<=k-1
        for(int i=1;i<=m;i++){
            scanf("%d %d %s %d",&a,&b,&str,&k);
            if(str[0]=='g') g[a-1].push_back({a+b,-k-1});
            else g[a+b].push_back({a-1,-1+k});
        }
        for(int i=0;i<=n;i++) g[n+1].push_back({i,0});
        if(spfa(n+1)) printf("lamentable kingdom\n");
        else printf("successful conspiracy\n");    
    }
    return 0;
} 

  

猜你喜欢

转载自www.cnblogs.com/vainglory/p/9150145.html